import java.util.*;
import java.lang.*;

/**
 * Title:        Main.java
 * Description:  Application for testing kmeans and fuzzy kmeans algorithms
 * Copyright:    Annemari Auvinen, Anu Niemi (c) 2002
 * Company:
 * @author       Annemari Auvinen, Anu Niemi
 * @version      1.0
 *
 */

 /*Algoritmi:
      1. muodostetaan satunnaisia ryppit (normaalijakautuneita
          erilaisilla keskiarvoilla ja variansseilla)
      2. ajetaan k-means ja saadaan keskiarvot
      3. ajetaan sumea k-means -"-
      4. lasketaan menetelmien tuottamat virheet ja talletetaan ne
      5. kohtaan 1
        Kierretn silmukkaa M kertaa. Vertaillaan tuloksia.
*/
public class Main {

/**
  * Constructor of Main.
  */
   public void Main() {}


   public void compare() {
   }

/**
  *
  */
   public double normdev()
  {
    int iset=0;
    double gset=0;
    double v1, v2, rsq, fac;

   if(iset == 0)
     {
       do {

       v1=java.lang.Math.random();
       if (java.lang.Math.random()<0.5)
         v1=v1*-1;
       v2=java.lang.Math.random();
       if (java.lang.Math.random()<0.5)
         v2=v2*-1;
         rsq = v1*v1+v2*v2;

     } while (rsq >= 1.0 || rsq == 0);

     fac = Math.sqrt(-2.*Math.log(rsq)/rsq);

     gset = v1*fac;
     iset = 1;
     return v2*fac;
   }
   else
   {
   iset = 0;
   return gset;
 }
}

/**
  * Caluculates distances of midpoints of different vectors.
  * @param  vector  Vector of midpoints
  * @param  given   Vector of midpoints
  * @return         Vector of calculated distances
  */
  public Vector calculate_dist(Vector vector,Vector given)
  {
    Vector distances = new Vector();
    for(int i=0; i<vector.size();i++) {
      Observation o = (Observation)vector.elementAt(i);
      Observation obs = (Observation)given.elementAt(i);
      double distance = Math.sqrt(Math.pow((obs.getX()-o.getX()),2.0)+Math.pow((obs.getY()-o.getY()),2.0));
      Membership m = new Membership(distance);
      distances.add(m);
    }
    return distances;
  }

   public static void main(String[] args) {
    Main main = new Main();
    Vector kmeansMp;
    Vector fuzzyMp;
    //vector of the distances vectors
    Vector distKmeans = new Vector();
    Vector distFuzzy = new Vector();
    Vector given = new Vector();
    int b = 2;  //width paramer
    int points=2500; //points per a cluster
    int m = 5;
    double x,y;
    Vector data= new Vector();
    Observation o;
    int k =2;  //number of clusters
    double epsilon = 0.01;
    //random midpoints and datapoints
    for (int p=0;p < m; p++)
    {
      given.removeAllElements();
      data.removeAllElements();
      for(int i=0;i<k;i++) {
        double value = Math.random()*10;
        double value2 = Math.random()*10;
        Observation obs = new Observation(value,value2);
        given.add(obs);
        for(int j=0;j<points;j++)
        {
          x= main.normdev()*2.5 + obs.getX() ;
          y= main.normdev()*2.5 + obs.getY();
          o= new Observation(x,y);
          data.add(o);
        }
      }
      Kmeans km = new Kmeans(data,k);
      //returns the midpoints of kmeans
      kmeansMp = km.getW();
      FuzzyKmeans fuzzy = new FuzzyKmeans(data, k, b, epsilon);
      fuzzy.iterate();
      //returns the midpoints of fuzzy kmeans
      fuzzyMp = fuzzy.getMidpoints();
      ArrangeVector a = new ArrangeVector();
      //given midpoints are arranged
      Vector arranged = a.arrange(given);
      Vector partDist = main.calculate_dist(kmeansMp, arranged);
      distKmeans.add(partDist);
      Vector partDist2 = main.calculate_dist(fuzzyMp, arranged);
      distFuzzy.add(partDist2);
  }

  for (int n=0;n<m;n++) {
    Vector v = (Vector)distKmeans.elementAt(n);
    Vector vs = (Vector)distFuzzy.elementAt(n);
    for (int l=0;l<k;l++) {
       Membership dist_k = (Membership)v.elementAt(l);
       Membership dist_s = (Membership)vs.elementAt(l);
       System.out.println("Kierros " + (n+1) +" keskipisteess "+(l+1)+" tavallisen virhe "+dist_k.getValue()+" ja sumean virhe "+dist_s.getValue());

    }
  }
   }
}